﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// 例3-20 定数int を使った名前付きオプション
// 注釈: これは見本となるコードではありません。このコードの目的は
//       C#に列挙型が導入されている理由を示すためのものです。
//       実際のコードでは列挙型を使用することになるでしょう(つまりこのコードはむしろ悪いコードの見本です)。
class Plane
{
    public const int Approaching = 0;
    public const int Leaving = 1;

    public Plane(string newIdentifier)
    {
        _identifier = newIdentifier;
    }

    public string Identifier
    {
        get { return _identifier; }
    }
    private readonly string _identifier;

    const double kilometersPerMile = 1.609344;

    public double SpeedInMilesPerHour
    {
        get
        {
            return SpeedInKilometersPerHour / kilometersPerMile;
        }
        set
        {
            // readonlyフィールドの場合、次のようなコードは記述できません:
            //
            //  _identifier += ": 速度が" + value + "に変更されました。";
            //
            // そのため、おそらくは「賢い」のであろう開発者であれば
            // 識別子を変更しないようなデバッグコードを作成することに
            // 注力するようになるでしょう:
            Console.WriteLine(Identifier + ": 速度が" + value + "に変更されました。");
            SpeedInKilometersPerHour = value * kilometersPerMile;
        }
    }

    public double SpeedInKilometersPerHour
    {
        get;
        set;
    }

    public int Direction { get; set; }
}