﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// 例3-36 オブジェクト初期化子をよりうまく使いこなせるようPlane を変更
class Plane
{
    // 使用されなくなったコンストラクタを削除します
    // public Plane(string newIdentifier)
    // {
    // Identifier = newIdentifier;
    // }
    public string Identifier
    {
        get;
        // プロパティをpublicにするため
        // アクセス修飾子を削除します
        set;
    }

    const double kilometersPerMile = 1.609344;

    public double SpeedInMilesPerHour
    {
        get
        {
            return SpeedInKilometersPerHour / kilometersPerMile;
        }
        set
        {
            SpeedInKilometersPerHour = value * kilometersPerMile;
        }
    }

    public double SpeedInKilometersPerHour
    {
        get;
        set;
    }

    public DirectionOfApproach Direction
    {
        get;
        set;
    }

    public PolarPoint3D Position
    {
        get;
        set;
    }

    public void SendMessage(
        string messageName,
        TimeSpan delay = default(TimeSpan))
    {
    }
}