﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

class Plane
{
    public Plane(string newIdentifier)
    {
        _identifier = newIdentifier;
    }

    public string Identifier
    {
        get { return _identifier; }
    }
    // 例3-19 読み取り専用フィールド
    private readonly string _identifier;

    const double kilometersPerMile = 1.609344;

    public double SpeedInMilesPerHour
    {
        get
        {
            return SpeedInKilometersPerHour / kilometersPerMile;
        }
        set
        {
            // readonlyフィールドの場合、次のようなコードは記述できません:
            //
            //  _identifier += ": 速度が" + value + "に変更されました。";
            //
            // そのため、おそらくは「賢い」のであろう開発者であれば
            // 識別子を変更しないようなデバッグコードを作成することに
            // 注力するようになるでしょう:
            Console.WriteLine(Identifier + ": 速度が" + value + "に変更されました。");
            SpeedInKilometersPerHour = value * kilometersPerMile;
        }
    }

    public double SpeedInKilometersPerHour
    {
        get;
        set;
    }
}