﻿using System.Text;

// 例4-19 頼みの綱：クラス階層を再考すべき
// 注釈: このコードはコンパイルできません。理由は本文を参照してください。
class Administrator : NamedPerson, SalariedPerson
{
    private decimal salary;
    public override decimal Salary
    {
        get
        {
            return salary;
        }
        set
        {
            salary = value;
        }
    }

    public override string Name
    {
        get
        {
            StringBuilder name = new StringBuilder();
            AppendWithSpace(name, Title);
            AppendWithSpace(name, Forename);
            AppendWithSpace(name, Surname);
            return name.ToString();
        }
    }

    public string Title { get; set; }
    public string Forename { get; set; }
    public string Surname { get; set; }

    void AppendWithSpace(StringBuilder builder, string stringToAppend)
    {
        // 追加すべき文字列が空なら何もせずに終了します。
        if (string.IsNullOrEmpty(stringToAppend))
        {
            return;
        }
        // すでに何らかのテキストがある場合にはスペースを追加してから文字列を追加します。
        if (builder.Length > 0)
        {
            builder.Append(" ");
        }
        builder.Append(stringToAppend);
    }
}
