﻿using System;
using System.Windows;

abstract class FirefighterBase
{
    // このメソッドではTrainHoseOnFireとTurnOnHoseを
    // 消火作業の一部として呼び出します。
    public abstract void ExtinguishFire();

    public string Name { get; set; }

    public void Drive(Firetruck truckToDrive, Point coordinates)
    {
        if (truckToDrive.Driver != this)
        {
            // 運転手でない場合は消防車を運転できません。
            return;
        }
        truckToDrive.Drive(coordinates);
    }
}