﻿using System;
using System.Windows;

abstract class FirefighterBase : INamedPerson, ISettableNamedPerson, ISalariedPerson
{
    public string Name
    {
        get;
        set;
    }
    public decimal Salary
    {
        get;
        set;
    }
    
    public abstract void ExtinguishFire();


    public void Drive(Firetruck truckToDrive, Point coordinates)
    {
        if (truckToDrive.Driver != this)
        {
            // 運転手でない場合は消防車を運転できません。
            return;
        }
        truckToDrive.Drive(coordinates);
    }
}