﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace FireTraining
{
    class Program
    {
        static void Main(string[] args)
        {
            Hiding1();
            Hiding2();
        }

        static void Hiding1()
        {
            // 例4-6 異なる参照型と、異なるメソッド

            // Harryのナンバー・ワンであるJoeへの参照
            Firefighter joe = new Firefighter { Name = "Joe" };

            // Firefighterのharryは、本当はJoeがお気に入りの消防署長
            FireChief harry = new FireChief { Name = "Harry", NumberOne = joe };
            Firefighter harryAsAFirefighter = harry;

            // Harryは単なる消防士なので、火を消すことができます。
            // しかし彼は消防署長なので、joeにその仕事を任命します。
            harry.ExtinguishFire();

            // 一方、消防士として彼が自分自身で火を消します。
            harryAsAFirefighter.ExtinguishFire();
        }

        static void Hiding2()
        {
            // 例4-7 メソッド隠蔽の分かりづらい用法

            // Harryのナンバー・ワンであるJoeへの参照
            Firefighter joe = new Firefighter { Name = "Joe" };

            // HarryはFireChiefであり、彼のナンバー・ワンはJoe
            FireChief harry = new FireChief { Name = "Harry", NumberOne = joe };

            // TomはFireChiefであり、彼のナンバー・ワンはHarry
            FireChief tom = new FireChief { Name = "Tom", NumberOne = harry };

            // Harryは単なる消防士なので、火を消すことができます。
            // しかし彼は消防署長なので、Joeにその仕事を任命します。
            harry.ExtinguishFire();

            // そしてTomが消火を依頼されると、彼はHarryを任命します。
            // 今回の方針ではharryは自分で仕事をこなさなければならず、
            // Joeに委任することはできません。
            tom.ExtinguishFire();
        }
    }
}
