﻿using System;
using System.Windows;

class Firefighter
{
    // このメソッドではTrainHoseOnFireとTurnOnHoseを
    // 消火作業の一部として呼び出します。
    public virtual void ExtinguishFire()
    {
        Console.WriteLine("{0}は消火作業中です！", Name);
        TrainHoseOnFire();
        TurnOnHose();
    }

    // 例4-10 派生クラスにメソッドを公開する
    protected virtual void TurnOnHose()
    {
        Console.WriteLine("火は消えつつあります。");
    }

    protected virtual void TrainHoseOnFire()
    {
        Console.WriteLine("ホースを火に向けています。");
    }

    public string Name { get; set; }

    public void Drive(Firetruck truckToDrive, Point coordinates)
    {
        if (truckToDrive.Driver != this)
        {
            // 運転手でない場合は消防車を運転できません。
            // ですが、何事もなかったかのように失敗するのは最悪です。
            // クライアントに失敗を知らせる手段を
            // 構造化したものが必要です。
            // この方法については6章で紹介します。
            return;
        }
        truckToDrive.Drive(coordinates);
    }
}