﻿using System;
using System.Collections.Generic;

// 例4-27 IClockInインタフェースの実装
class FireStation : IClockIn
{
    List<INamedPerson> clockedInStaff = new List<INamedPerson>();
    public void ClockIn(INamedPerson staffMember)
    {
        if (!clockedInStaff.Contains(staffMember))
        {
            clockedInStaff.Add(staffMember);
            Console.WriteLine("{0}が出勤しました。", staffMember.Name);
        }
    }
    public void RollCall()
    {
        foreach (INamedPerson staffMember in clockedInStaff)
        {
            Console.WriteLine(staffMember.Name);
        }
    }

    // 代替案1：
    //public void ClockIn(object item)
    //{
    //    if (item is INamedPerson)
    //    {
    //        ClockIn(item as INamedPerson);
    //    }
    //    else
    //    {
    //        Console.WriteLine("型'{0}'は登録できません。", item.GetType());
    //    }
    //}

    // 代替案2：
    public void ClockIn(object item)
    {
        INamedPerson namedPerson = item as INamedPerson;
        if (namedPerson != null)
        {
            ClockIn(namedPerson);
        }
        else
        {
            Console.WriteLine("型'{0}'は登録できません。", item.GetType());
        }
    }
}