﻿using System;

namespace DocumentProcessing
{
    class ProcessEventArgs : EventArgs
    {
        // 単純なコンストラクター
        public ProcessEventArgs(Document document)
        {
            Document = document;
        }

        // 追加プロパティ。
        // 購読者がこのプロパティを変更できないようにしたいので、
        // setアクセサーをprivateにします。
        // (もちろん、この制限がDocumentそのものの変更を
        // 阻害することはありません)
        public Document Document
        {
            get;
            private set;
        }
    }
}
