﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DocumentProcessing
{
    // 例5-12 組み込みのAction<T>デリゲート型を使うようにプロセッサーを変更
    class DocumentProcessor
    {
        private readonly List<Action<Document>> processes =
            new List<Action<Document>>();

        public List<Action<Document>> Processes
        {
            get
            {
                return processes;
            }
        }

        public void Process(Document doc)
        {
            foreach (Action<Document> process in Processes)
            {
                process(doc);
            }
        }
    }
}
