﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DocumentProcessing
{
    class Program
    {
        static void Main(string[] args)
        {
            Document doc1 = new Document
            {
                Author = "Matthew Adams",
                DocumentDate = new DateTime(2000, 01, 01),
                Text = "Am I a year early?"
            };

            Document doc2 = new Document
            {
                Author = "Ian Griffiths",
                DocumentDate = new DateTime(2001, 01, 01),
                Text = "This is the new millenium, I promise you."
            };

            DocumentProcessor processor = Configure();

            Console.WriteLine("文書1を処理しています。");
            processor.Process(doc1);
            Console.WriteLine();
            Console.WriteLine("文書2を処理しています。");
            processor.Process(doc2);

            Console.ReadKey();
        }

        static DocumentProcessor Configure()
        {
            DocumentProcessor rc = new DocumentProcessor();
            rc.Processes.Add(DocumentProcesses.TranslateIntoFrench);
            rc.Processes.Add(DocumentProcesses.Spellcheck);
            rc.Processes.Add(DocumentProcesses.Repaginate);

            TrademarkFilter trademarkFilter = new TrademarkFilter();
            trademarkFilter.Trademarks.Add("O'Reilly");
            trademarkFilter.Trademarks.Add("millenium");

            rc.Processes.Add(trademarkFilter.HighlightTrademarks);

            return rc;
        }
    }
}
