﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ErrorExample
{
    class Program
    {
        static void Main(string[] args)
        {
            Turtle arthurTheTurtle = new Turtle
                { PlatformWidth = 0.0, PlatformHeight = 10.0, MotorSpeed = 5.0
            };

            ShowPosition(arthurTheTurtle);

            try
            {
                // 例6-22 期待される例外のテスト
                arthurTheTurtle.RunFor(0.0);

                // 前進させます
                arthurTheTurtle.LeftMotorState = MotorState.Running;
                arthurTheTurtle.RightMotorState = MotorState.Running;

                // 2秒間
                arthurTheTurtle.RunFor(2.0);

                ShowPosition(arthurTheTurtle);

                // 次に時計回りに少し回転させます
                arthurTheTurtle.RightMotorState = MotorState.Reversed;

                // PI/2 秒で十分でしょう
                arthurTheTurtle.RunFor(Math.PI / 2.0);

                ShowPosition(arthurTheTurtle);

                // そして後退を試します
                arthurTheTurtle.RightMotorState = MotorState.Reversed;
                arthurTheTurtle.LeftMotorState = MotorState.Reversed;

                // 5秒間走行します
                arthurTheTurtle.RunFor(5);

                ShowPosition(arthurTheTurtle);

                // 反時計回りに回転します
                arthurTheTurtle.RightMotorState = MotorState.Running;

                // PI/4 秒回転すれば45度になるはずです
                arthurTheTurtle.RunFor(Math.PI / 4.0);

                ShowPosition(arthurTheTurtle);

                // 最後に少し後方へ走行します
                arthurTheTurtle.RightMotorState = MotorState.Reversed;
                arthurTheTurtle.LeftMotorState = MotorState.Reversed;
                arthurTheTurtle.RunFor(Math.Cos(Math.PI / 4.0));

                ShowPosition(arthurTheTurtle);
            }
            catch (InvalidOperationException e)
            {
                Console.WriteLine("タートルの走行中にエラー発生：");
                Console.WriteLine(e.Message);
            }
            catch (Exception e1)
            {
                // InnerExceptionを走査して、
                // すべての内部例外のメッセージを出力します
                Exception current = e1;
                while (current != null)
                {
                    Console.WriteLine(current.Message);
                    current = current.InnerException;
                }
            }
            finally
            {
                Console.WriteLine("finallyブロックで待機中...");
                Console.ReadKey();
            }
        }

        private static void ShowPosition(Turtle arthurTheTurtle)
        {
            Console.WriteLine(
                "Arthurの位置は ({0})、方向は {1:0.00} ラジアンです。",
                arthurTheTurtle.CurrentPosition,
                arthurTheTurtle.CurrentOrientation);
        }
    }
}
