﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ErrorExample
{
    class Program
    {
        //例6-10 エラー処理
        static void Main(string[] args)
        {
            Turtle arthurTheTurtle =
                new Turtle
                {
                    PlatformWidth = 0.0,
                    PlatformHeight = 10.0,
                    MotorSpeed = 5.0
                };

            ShowPosition(arthurTheTurtle);

            // 前進させます
            arthurTheTurtle.LeftMotorState = MotorState.Running;
            arthurTheTurtle.RightMotorState = MotorState.Running;

            // 2秒間
            TurtleError result = arthurTheTurtle.RunFor(2.0);

            if (result != TurtleError.OK)
            {
                HandleError(result);
                return;
            }

            ShowPosition(arthurTheTurtle);

            // 次に時計回りに少し回転させます
            arthurTheTurtle.RightMotorState = MotorState.Reversed;

            // PI/2 秒で十分でしょう
            result = arthurTheTurtle.RunFor(Math.PI / 2.0);
            if (result != TurtleError.OK)
            {
                HandleError(result);
                return;
            }

            ShowPosition(arthurTheTurtle);

            // そして後退を試します
            arthurTheTurtle.RightMotorState = MotorState.Reversed;
            arthurTheTurtle.LeftMotorState = MotorState.Reversed;

            // 5秒間走行します
            result = arthurTheTurtle.RunFor(5);
            if (result != TurtleError.OK)
            {
                HandleError(result);
                return;
            }

            ShowPosition(arthurTheTurtle);

            // 反時計回りに回転します
            arthurTheTurtle.RightMotorState = MotorState.Running;

            // PI/4 秒回転すれば45度になるはずです
            result = arthurTheTurtle.RunFor(Math.PI / 4.0);
            if (result != TurtleError.OK)
            {
                HandleError(result);
                return;
            }

            ShowPosition(arthurTheTurtle);

            // 最後に少し後方へ走行します
            arthurTheTurtle.RightMotorState = MotorState.Reversed;
            arthurTheTurtle.LeftMotorState = MotorState.Reversed;
            result = arthurTheTurtle.RunFor(Math.Cos(Math.PI / 4.0));
            if (result != TurtleError.OK)
            {
                HandleError(result);
                return;
            }

            ShowPosition(arthurTheTurtle);

            Console.ReadKey();
        }

        private static void HandleError(TurtleError result)
        {
            Console.WriteLine("タートルにエラーが発生しました：{0}", result);
            Console.ReadKey();
        }

        private static void ShowPosition(Turtle arthurTheTurtle)
        {
            Console.WriteLine(
                "Arthurの位置は ({0})、方向は {1:0.00} ラジアンです。",
                arthurTheTurtle.CurrentPosition,
                arthurTheTurtle.CurrentOrientation);
        }
    }
}
