﻿using System;

namespace ArrayCopying
{
    class Program
    {
        static void Main(string[] args)
        {
            CalendarEvent[] events1 =
            {
                new CalendarEvent
                {
                    Title = "サウスバンクでスウィング・ダンス",
                    StartTime = new DateTimeOffset (2009, 7, 11, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "サタデー・ナイト・スウィング",
                    StartTime = new DateTimeOffset (2009, 7, 11, 19, 30, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(6.5)
                }
            };

            CalendarEvent[] events2 =
            {
                new CalendarEvent
                {
                    Title = "F1 ドイツグランプリ",
                    StartTime = new DateTimeOffset (2009, 7, 12, 12, 10, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(3)
                },
                new CalendarEvent
                {
                    Title = "スウィング・ダンス・ピクニック",
                    StartTime = new DateTimeOffset (2009, 7, 12, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "100 Clubでのスウィングダンスイベント",
                    StartTime = new DateTimeOffset (2009, 7, 13, 19, 45, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(5)
                }
            };

            CalendarEvent[] allEvents = CombineEvents(events1, events2);
            PrintEvents(allEvents);
            Console.WriteLine();
            PrintEvents(RemoveFirstEvent(allEvents));
        }

        // 例7-18 2つの配列の要素を複製して1つの大きな配列にする
        static CalendarEvent[] CombineEvents(CalendarEvent[] events1,
            CalendarEvent[] events2)
        {
            CalendarEvent[] combinedEvents =
            new CalendarEvent[events1.Length + events2.Length];
            events1.CopyTo(combinedEvents, 0);
            events2.CopyTo(combinedEvents, events1.Length);
            return combinedEvents;
        }

        // 例7-19 配列の一部をコピーする
        static CalendarEvent[] RemoveFirstEvent(CalendarEvent[] events)
        {
            CalendarEvent[] croppedEvents = new CalendarEvent[events.Length - 1];
            Array.Copy(
                events,             // コピー元の配列
                1,                  // コピー元の開始地点
                croppedEvents,      // コピー先の配列
                0,                  // コピー先での開始地点
                events.Length - 1   // コピーする要素数
            );
            return croppedEvents;
        }

        static void PrintEvents(CalendarEvent[] events)
        {
            foreach (CalendarEvent item in events)
            {
                Console.WriteLine(item.Title + ": " + item.StartTime);
            }
        }
    }
}
