﻿using System;

namespace ArrayInitialization
{
    class Program
    {
        // 例7-3 動的な配列の生成
        static string[] AddNumbers(string[] names)
        {
            string[] numberedNames = new string[names.Length];
            for (int i = 0; i < names.Length; ++i)
            {
                numberedNames[i] = string.Format("{0}: {1}", i, names[i]);
            }
            return numberedNames;
        }

        static void Main(string[] args)
        {
            // 例7-4 初期化リストの挙動s
            string[] eventNames = new string[5];
            eventNames[0] = "サウスバンクでスウィング・ダンス";
            eventNames[1] = "サタデー・ナイト・スウィング";
            eventNames[2] = "F1 ドイツグランプリ";
            eventNames[3] = "スウィング・ダンス・ピクニック";
            eventNames[4] = "100 Clubでのスウィングダンスイベント";

            ShowArray(eventNames);

            ShowArray(AddNumbers(eventNames));


            // 例7-5 配列の初期化失敗
            // 以下のfalseをtrueに変更するとコンパイルエラーが発生することが確認できます。
#if false
            // このコードはコンパイルできません！
            eventNames =
            {
                "Dean Collinsによるシムシャムレッスン",
                "リンディホップの中級レッスン",
                "Wild Times - ワイルド・コートでソーシャルダンス"
            };
#endif

            // 例7-6 明示的な要素の型の宣言と初期化リストの組み合わせ

            // コンパイルできます！
            eventNames = new string[]
            {
                "Dean Collinsによるシムシャムレッスン",
                "リンディホップの中級レッスン",
                "Wild Times - ワイルド・コートでソーシャルダンス"
            };

            ShowArray(eventNames);

            // 例7-7 インラインの配列初期化
            string[] result = AddNumbers(new string[] { "ジャズ・デヴィルズ", "スウィング・ダンサー" });

            ShowArray(result);
        }

        static void ShowArray(string[] array)
        {
            foreach (string item in array)
            {
                Console.WriteLine(item);
            }
            Console.WriteLine();
        }
    }
}
