﻿using System.Collections.Generic;

namespace PolymorphicCollections
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] fromArray = AddNumbers(new string[] { "A", "B", "C" });
            List<string> list = new List<string> { "A", "B", "C" };
            string[] fromList = AddNumbers(list);
        }

        // 例7-30 IEnumerable<T>とIEnumerator<T>の利用
        static string[] AddNumbers(IEnumerable<string> names)
        {
            List<string> numberedNames = new List<string>();
            using (IEnumerator<string> enumerator = names.GetEnumerator())
            {
                int i = 0;
                while (enumerator.MoveNext())
                {
                    string currentName = enumerator.Current;
                    numberedNames.Add(string.Format("{0}: {1}", i, currentName));
                    i += 1;
                }
            }
            return numberedNames.ToArray();
        }
    }

    class ForEachExample
    {
        // 例7-31 IEnumerable<T>に対するforeach
        static string[] AddNumbers(IEnumerable<string> names)
        {
            List<string> numberedNames = new List<string>();
            int i = 0;
            foreach (string currentName in names)
            {
                numberedNames.Add(string.Format("{0}: {1}", i, currentName));
                i += 1;
            }
            return numberedNames.ToArray();
        }
    }

    class EnumerableExample
    {
        // 例7-32 yield returnによるIEnumerable<T>の実装
        static IEnumerable<string> AddNumbers(IEnumerable<string> names)
        {
            int i = 0;
            foreach (string currentName in names)
            {
                yield return string.Format("{0}: {1}", i, currentName);
                i += 1;
            }
        }
    }
}
