﻿using System;
using System.Collections.Generic;

namespace YieldReturn
{
    // 例7-33 yield returnの調査
    class Program
    {
        static IEnumerable<string> AddNumbers(IEnumerable<string> names)
        {
            Console.WriteLine("AddNumbersを開始");
            int i = 0;
            foreach (string currentName in names)
            {
                Console.WriteLine("AddNumbers内: " + currentName);
                yield return string.Format("{0}: {1}", i, currentName);
                i += 1;
            }
            Console.WriteLine("AddNumbersを終了");
        }

        static void Main(string[] args)
        {
            string[] eventNames =
            {
                "サウスバンクでスウィング・ダンス",
                "サタデー・ナイト・スウィング",
                "F1 ドイツグランプリ",
                "スウィング・ダンス・ピクニック",
                "100 Clubでのスウィングダンスイベント"
            };

            Console.WriteLine("AddNumbersの呼び出し");
            IEnumerable<string> numberedNames = AddNumbers(eventNames);
            Console.WriteLine("メインループ開始");
            foreach (string numberedName in numberedNames)
            {
                Console.WriteLine("メインループ内: " + numberedName);
            }
            Console.WriteLine("メインループ終了");
        }
    }
}
