﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Collections;

namespace Conversions
{
    class Program
    {
        static void Main(string[] args)
        {
            List<CalendarEvent> events = new List<CalendarEvent>
            {
                new CalendarEvent
                {
                    Title = "サウスバンクでスウィングダンス",
                    StartTime = new DateTimeOffset (2009, 7, 11, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "土曜の夜はスウィング",
                    StartTime = new DateTimeOffset (2009, 7, 11, 19, 30, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(6.5)
                },
                new CalendarEvent
                {
                    Title = "F1ドイツグランプリ",
                    StartTime = new DateTimeOffset (2009, 7, 12, 12, 10, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(3)
                },
                new CalendarEvent
                {
                    Title = "スウィングダンスピクニック",
                    StartTime = new DateTimeOffset (2009, 7, 12, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "100クラブでストンプ",
                    StartTime = new DateTimeOffset (2009, 7, 13, 19, 45, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(5)
                }
            };

            var eventsByDay = from ev in events
                              group ev by ev.StartTime.Date into dayGroup
                              select dayGroup.ToArray();

            CalendarEvent[][] arrayOfEventsByDay = eventsByDay.ToArray();

            foreach (var days in arrayOfEventsByDay)
            {
                foreach (var eventByDay in days)
                {
                    Console.WriteLine(eventByDay.Title + ": " + eventByDay.StartTime);
                }
                Console.WriteLine();
            }

            IEnumerable oldEnum = GetCollectionFromSomewhere();
            var items = from ev in oldEnum.Cast<CalendarEvent>()
                        orderby ev.StartTime
                        select ev;
            foreach (var item in items)
            {
                Console.WriteLine(item.Title + ": " + item.StartTime);
            }
        }

        private static IEnumerable GetCollectionFromSomewhere()
        {
            return new ArrayList
            {
                new CalendarEvent
                {
                    Title = "F1ドイツグランプリ",
                    StartTime = new DateTimeOffset (2009, 7, 12, 12, 10, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(3)
                },
                new CalendarEvent
                {
                    Title = "スウィングダンスピクニック",
                    StartTime = new DateTimeOffset (2009, 7, 12, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
               new CalendarEvent
                {
                    Title = "サウスバンクでスウィングダンス",
                    StartTime = new DateTimeOffset (2009, 7, 11, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "土曜の夜はスウィング",
                    StartTime = new DateTimeOffset (2009, 7, 11, 19, 30, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(6.5)
                },
                new CalendarEvent
                {
                    Title = "100クラブでストンプ",
                    StartTime = new DateTimeOffset (2009, 7, 13, 19, 45, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(5)
                }
            };
        }
    }
}
