﻿using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace DelegatesAndLambdas
{
    class Program
    {
        static IEnumerable<string> GetAllFilesInDirectory(string directoryPath)
        {
            return Directory.EnumerateFiles(directoryPath, "*",
                SearchOption.AllDirectories);
        }

        static void Main(string[] args)
        {
            SideEffects();

            LocalVariable();
        }

        static void SideEffects()
        {
            // 例8-8 クエリ中では役立たない副作用
            int x = 10000;
            var bigFiles = from file in GetAllFilesInDirectory(@"c:\")
                           where new FileInfo(file).Length > x++
                           select file;
        }


        static void LocalVariable()
        {
            // 例8-9 クエリ中でローカル変数を参照する
            int minSize = 10000;
            var bigFiles = from file in GetAllFilesInDirectory(@"c:\")
                           where new FileInfo(file).Length > minSize
                           select file;
            var filesOver10k = bigFiles.ToArray();
            minSize = 100000;
            var filesOver100k = bigFiles.ToArray();
            minSize = 1000000;
            var filesOver1MB = bigFiles.ToArray();
            minSize = 10000000;
            var filesOver10MB = bigFiles.ToArray();
        }

    }
}
