﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Joining
{
    class Program
    {
        static void Main(string[] args)
        {
            List<CalendarEvent> events = new List<CalendarEvent>
            {
                new CalendarEvent
                {
                    Title = "サウスバンクでスウィングダンス",
                    StartTime = new DateTimeOffset (2009, 7, 11, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "土曜の夜はスウィング",
                    StartTime = new DateTimeOffset (2009, 7, 11, 19, 30, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(6.5)
                },
                new CalendarEvent
                {
                    Title = "F1ドイツグランプリ",
                    StartTime = new DateTimeOffset (2009, 7, 12, 12, 10, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(3)
                },
                new CalendarEvent
                {
                    Title = "スウィングダンスピクニック",
                    StartTime = new DateTimeOffset (2009, 7, 12, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "100クラブでストンプ",
                    StartTime = new DateTimeOffset (2009, 7, 13, 19, 45, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(5)
                }
            };

            List<PhoneEvent> phoneEvents = new List<PhoneEvent>
            {
                new PhoneEvent
                {
                    Name = "サウスバンクでスウィングダンス",
                    Time = new DateTimeOffset (2009, 7, 11, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new PhoneEvent
                {
                    Name = "土曜の夜はスウィング",
                    Time = new DateTimeOffset (2009, 7, 11, 19, 30, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(6.5)
                }
            };

            var pairs = from localEvent in events
                        join phoneEvent in phoneEvents
                            on new { Title = localEvent.Title, Start = localEvent.StartTime }
                            equals new { Title = phoneEvent.Name, Start = phoneEvent.Time }
                        select new { Local = localEvent, Phone = phoneEvent };
            foreach (var item in pairs)
            {
                Console.WriteLine(item.Local.Title + ": " + item.Local.StartTime);
            }
        }
    }
}
