﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Ordering
{
    class Program
    {
        static void Main(string[] args)
        {
            // 例8-11 サンプル用のデータ
            List<CalendarEvent> events = new List<CalendarEvent>
            {
                new CalendarEvent
                {
                    Title = "サウスバンクでスウィング・ダンス",
                    StartTime = new DateTimeOffset(2009, 7, 11, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "サタデー・ナイト・スウィング",
                    StartTime = new DateTimeOffset(2009, 7, 11, 19, 30, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(6.5)
                },
                new CalendarEvent
                {
                    Title = "ドイツ F1グランプリ",
                    StartTime = new DateTimeOffset(2009, 7, 12, 12, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(3)
                },
                new CalendarEvent
                {
                    Title = "スウィング・ダンス・ピクニック",
                    StartTime = new DateTimeOffset(2009, 7, 12, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "100 Clubでのスウィングダンスイベント",
                    StartTime = new DateTimeOffset (2009, 7, 13, 19, 45, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(5)
                }
            };

            // 例8-12 LINQによる並べ替え
            var eventsByStartTime = from ev in events
                                    orderby ev.StartTime
                                    select ev;

            PrintEvents(eventsByStartTime);

            // 例8-13 複数条件によるソート
            var eventsByStartDateThenDuration = from ev in events
                                                orderby ev.StartTime.Date, ev.Duration
                                                select ev;

            PrintEvents(eventsByStartDateThenDuration);

        }



        static void PrintEvents(IEnumerable<CalendarEvent> events)
        {
            foreach (CalendarEvent item in events)
            {
                Console.WriteLine(item.Title + ": " + item.StartTime);
            }
        }
    }
}
