﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace TestingTheWholeCollection
{
    class Program
    {
        static void Main(string[] args)
        {
            List<CalendarEvent> events = new List<CalendarEvent>
            {
                new CalendarEvent
                {
                    Title = "サウスバンクでスウィングダンス",
                    StartTime = new DateTimeOffset (2009, 7, 11, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "土曜の夜はスウィング",
                    StartTime = new DateTimeOffset (2009, 7, 11, 19, 30, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(6.5)
                },
                new CalendarEvent
                {
                    Title = "F1ドイツグランプリ",
                    StartTime = new DateTimeOffset (2009, 7, 12, 12, 10, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(3)
                },
                new CalendarEvent
                {
                    Title = "スウィングダンスピクニック",
                    StartTime = new DateTimeOffset (2009, 7, 12, 15, 00, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(4)
                },
                new CalendarEvent
                {
                    Title = "100クラブでストンプ",
                    StartTime = new DateTimeOffset (2009, 7, 13, 19, 45, 00, TimeSpan.Zero),
                    Duration = TimeSpan.FromHours(5)
                }
            };

            DateTimeOffset newEventStart = new DateTimeOffset(2009, 7, 20, 19, 45, 00,
                TimeSpan.Zero);
            TimeSpan newEventDuration = TimeSpan.FromHours(5);
            bool overlaps = events.Any(
                ev => TimesOverlap(ev.StartTime, ev.Duration,
                    newEventStart, newEventDuration));

            bool noOverlaps = events.All(
                ev => !TimesOverlap(ev.StartTime, ev.Duration,
                    newEventStart, newEventDuration));
        }

        static bool TimesOverlap(DateTimeOffset startTime1, TimeSpan duration1,
            DateTimeOffset startTime2, TimeSpan duration2)
        {
            DateTimeOffset end1 = startTime1 + duration1;
            DateTimeOffset end2 = startTime2 + duration2;

            return (startTime1 < startTime2) ?
                (startTime2 < end1) :
                (startTime1 < end2);
        }
    }
}
