﻿using System.Collections.Generic;
using System;

namespace DictionaryExamples
{
    // 例9-7 数値型のスパース配列
    class SparseArray
    {
        private Dictionary<long, double> nonEmptyValues = new Dictionary<long, double>();
        public double this[long index]
        {
            get
            {
                double result;
                nonEmptyValues.TryGetValue(index, out result);
                return result;
            }
            set
            {
                nonEmptyValues[index] = value;
            }
        }

        // 例9-9 ディクショナリの走査
        public void ShowArrayContents()
        {
            foreach (var item in nonEmptyValues)
            {
                Console.WriteLine("キー: '{0}', 値: '{1}'",
                    item.Key, item.Value);
            }
        }
    }
}
