﻿using System;
using System.Globalization;
using System.Linq;

namespace CultureExamples
{
    class Program
    {
        static void Main(string[] args)
        {
            // 例10-46 利用可能なカルチャーを表示する
            var cultures = CultureInfo.GetCultures(CultureTypes.AllCultures).
                OrderBy(c => c.EnglishName);
            foreach (var culture in cultures)
            {
                Console.WriteLine("{0} : {1}", culture.EnglishName, culture.Name);
            }

            // 例10-47 異なるカルチャーにおける数値の書式設定
            CultureInfo englishUS = CultureInfo.CreateSpecificCulture("en-US");
            CultureInfo french = CultureInfo.CreateSpecificCulture("fr");
            double value = 1.8;
            Console.WriteLine(value.ToString(englishUS));
            Console.WriteLine(value.ToString(french));
        }
    }
}
