﻿using System;

namespace Formatting
{
    class Program
    {
        static void Main(string[] args)
        {
            {
                // 例10-5 ToString を使用して数字を文字列に変換する
                int myValue = 45;
                string myString = myValue.ToString();
                Console.WriteLine(myString);
            }

            {
                // 例10-6 decimal のToString を呼ぶ
                decimal myValue = 45.65M;
                string myString = myValue.ToString();
                Console.WriteLine(myString);
            }

            {
                // 例10-7 通貨の書式
                decimal dollarAmount = 123165.4539M;
                string text = dollarAmount.ToString("C");
                Console.WriteLine(text);
            }

            {
                // 例10-8 通貨書式における少数位の指定
                decimal dollarAmount = 123165.4539M;
                string text = dollarAmount.ToString("C3");
                Console.WriteLine(text);
            }

            {
                // 例10-9 精度を明示した10 進数書式
                int amount = 1654539;
                string text = amount.ToString("D9");
                Console.WriteLine(text);
            }

            {
                // 例10-10 精度を指定しない10 進数書式
                int amount = -2895729;
                string text = amount.ToString("D");
                Console.WriteLine(text);
            }

            {
                // 例10-11 16 進数書式
                int amount = 256;
                string text = amount.ToString("X");
                Console.WriteLine(text);
            }

            {
                // 例10-12 明示的な精度つきの16 進数書式
                int amount = 256;
                string text = amount.ToString("X4");
                Console.WriteLine(text);
            }

            {
                // 例10-13 指数形式
                double amount = 254.23875839484;
                string text = amount.ToString("E4");
                Console.WriteLine(text);
            }

            {
                // 例10-14 精度なしの指数形式
                double amount = 254.23875839484;
                string text = amount.ToString("E");
                Console.WriteLine(text);
            }

            {
                // 例10-15 固定小数点書式
                double amount = 152.68385485;
                string text = amount.ToString("F4");
                Console.WriteLine(text);
            }

            {
                // 例10-16 ゼロによる補間が生じた固定小数点書式
                double amount = 152.68;
                string text = amount.ToString("F4");
                Console.WriteLine(text);
            }

            {
                // 例10-17 一般書式
                double amount = 152.68;
                string text = amount.ToString("G4");
                Console.WriteLine(text);

                double amount2 = 0.00000000000015268;
                text = amount2.ToString("G4");
                Console.WriteLine(text);
            }

            {
                // 例10-18 数値書式
                double amount = 1520494.684848;
                string text = amount.ToString("N4");
                Console.WriteLine(text);
            }

            {
                // 例10-19 パーセント書式
                double amount = 0.684848;
                string text = amount.ToString("P4");
                Console.WriteLine(text);
            }

            {
                // 例10-20 ラウンドトリップ書式
                double amount = 0.684848;
                string text = amount.ToString("R");
                Console.WriteLine(text);
            }

            {
                // 例10-21 カスタム数値書式
                double value = 12.3456;
                Console.WriteLine(value.ToString("00.######"));

                value = 1.23456;
                Console.WriteLine(value.ToString("00.000000"));

                Console.WriteLine(value.ToString("##.000000"));
            }

            {
                string text;

                // 例10-22 小数点以下のプレースホルダー
                double value = 1234.5678;
                text = value.ToString("#.###");
                Console.WriteLine(text);
            }

            {
                // 例10-23 プレースホルダーと行頭および行末のゼロ
                double value = 0.46;
                string text = value.ToString("#.###");
                Console.WriteLine(text);
            }

            {
                // 例10-24 桁をグループ化するためのカンマ
                int value = 12345678;
                string text = value.ToString("#,#");
                Console.WriteLine(text);
            }

            {
                // 例10-25 出力をカンマで位取りする
                int value = 12345678;
                string text = value.ToString("#,#,,.");
                Console.WriteLine(text);
            }

            {
                // 例10-26 暗黙的な小数点
                int value = 12345678;
                string text = value.ToString("#,#,,");
                Console.WriteLine(text);
            }

            {
                // 例10-27 カスタム数値書式文字列における任意のテキスト
                int value = 12345678;
                string text = value.ToString("###-### 余り ###");
                Console.WriteLine(text);
            }

            {
                // 例10-28 カスタム書式文字列内における文字のエスケープ
                int value = 12345678;
                string text = value.ToString("###-### \\# ###");
                Console.WriteLine(text);
            }

            {
                // 例10-29 逐語的文字列リテラルで書式文字列
                int value = 12345678;
                string text = value.ToString(@"###-### \# ###");
                Console.WriteLine(text);
            }

            {
                // 例10-30 カスタム書式文字列内の文字列リテラル
                int value = 12345678;
                string text = value.ToString(@"###-### \# ### 'は 数字 です'");
                Console.WriteLine(text);
            }

            {
                // 例10-31 カスタム書式文字列内におけるパーセンテージ
                double value = 0.95;
                string text = value.ToString("#0.##%");
                Console.WriteLine(text);
            }

            {
                // 例10-32 DateTimeOffset をユーザに表示するための準備
                DateTimeOffset tmo = GetTimeFromSomewhere();
                DateTime localDateTime = tmo.ToLocalTime().DateTime;
                Console.WriteLine(localDateTime);
            }

            {
                // 例10-33 さまざまな書式での日付
                DateTime time = new DateTime(2001, 12, 24, 13, 14, 15, 16);
                Console.WriteLine(time.ToString("d"));
                Console.WriteLine(time.ToShortDateString());
                Console.WriteLine(time.ToString("D"));
                Console.WriteLine(time.ToLongDateString());
            }

            {
                // 例10-34 時間のみを取得する
                DateTime time = new DateTime(2001, 12, 24, 13, 14, 15, 16);
                Console.WriteLine(time.ToString("t"));
                Console.WriteLine(time.ToShortTimeString());
                Console.WriteLine(time.ToString("T"));
                Console.WriteLine(time.ToLongTimeString());
            }

            {
                // 例10-35 時間と日付を両方得る
                DateTime time = new DateTime(2001, 12, 24, 13, 14, 15, 16);
                Console.WriteLine(time.ToString("g"));
                Console.WriteLine(time.ToString("G"));
                Console.WriteLine(time.ToString("f"));
                Console.WriteLine(time.ToString("F"));
            }

            {
                // 例10-36 DateTime 用のラウンドトリップ書式
                DateTime time = new DateTime(2001, 12, 24, 13, 14, 15, 16);
                Console.WriteLine(time.ToString("O"));
            }

            {
                // 例10-37 世界共通のソート可能書式
                DateTime time = new DateTime(2001, 12, 24, 13, 14, 15, 16);
                Console.WriteLine(time.ToString("u"));
            }

            {
                // 例10-38 日付の書式設定
                DateTime time = new DateTime(2001, 12, 24, 13, 14, 15, 16);
                Console.WriteLine(time.ToString("dddd"));
                Console.WriteLine(time.ToString("ddd"));
                Console.WriteLine(time.ToString("dd"));
            }

            {
                // 例10-39 文字列から整数へ変換
                int converted = Convert.ToInt32("35");
                Console.WriteLine(converted);
            }

            {
                // 例10-40 16 進数文字列を整数に変換する
                int converted = Convert.ToInt32("35", 16);
                Console.WriteLine(converted);
                converted = Convert.ToInt32("0xFF", 16);
                Console.WriteLine(converted);
            }

            {
                try
                {
                    // 例10-41 数値ではない文字列を数字に変換しようとする
                    double converted = Convert.ToDouble("この文字列は変換できますか？");
                }
                catch (FormatException)
                {
                    Console.WriteLine("変換できませんでした。");
                }
            }

            {
                // 例10-42 TryParse を利用して例外を回避する
                int parsed;
                if (!int.TryParse("この文字列は変換できますか？", out parsed))
                {
                    Console.WriteLine("変換できませんでした。");
                }
            }

            {
                // 例10-43 DateTime.ParseExact
                DateTime dt =
                    DateTime.ParseExact("12^04^2008", "dd^MM^yyyy", System.Globalization.CultureInfo.CurrentCulture);
                Console.WriteLine(dt);
            }
        }

        private static DateTimeOffset GetTimeFromSomewhere()
        {
            return DateTimeOffset.UtcNow;
        }
    }
}
