﻿using System;

namespace Literals
{
    class Program
    {
        static void Main(string[] args)
        {
            // 注釈：以下のコードでは波括弧を使用してスコープを区分しています。
            // このようにすることで変数を各スコープのローカル変数にできるため、
            // 同じメソッド中で"myString"という変数名を複数回
            // 使用できるようになります。

            {
                // 例10-2 文字列リテラル
                string myString = "Literal string";
                Console.WriteLine(myString);
            }

            {
                // 例10-3 char リテラルからの文字列の初期化
                string myString = new string(new[] { 'H', 'e', 'l', 'l', 'o', ' ', '"', 'w', 'o', 'r', 'l', 'd', '"' });
                Console.WriteLine(myString);
            }

            // 例10-4 逐語的文字列リテラルによるバックスラッシュの回避
            string multiLineString =
            @"Lots of
lines and
        tabs!";
            Console.WriteLine(multiLineString);
        }

    }
}
