﻿using System;

namespace Splitting
{
    class Program
    {
        static void Main(string[] args)
        {
            {
                // 例10-59 文字列の分割
                string[] strings = Soliloquize();
                string output = String.Join(Environment.NewLine, strings);
                string[] splitStrings = output.Split(
                    new char[] { ' ', '\t', '\r', '\n', ',', '-', ':' });
                bool first = true;
                foreach (string splitBit in splitStrings)
                {
                    if (first)
                    {
                        first = false;
                    }
                    else
                    {
                        Console.Write(", ");
                    }
                    Console.Write(splitBit);
                }
            }

            Console.WriteLine();

            {
                string[] strings = Soliloquize();
                string output = String.Join(Environment.NewLine, strings);

                // 例10-60 String.Split における空文字列の削除
                string[] splitStrings = output.Split(
                    new char[] { ' ', '\t', '\r', '\n', ',', '-', ':' },
                    StringSplitOptions.RemoveEmptyEntries);

                bool first = true;
                foreach (string splitBit in splitStrings)
                {
                    if (first)
                    {
                        first = false;
                    }
                    else
                    {
                        Console.Write(", ");
                    }
                    // 例10-61 文字列を小文字にする
                    Console.Write(splitBit.ToLower());
                }
            }
        }

        private static string[] Soliloquize()
        {
            return new string[] {
                "To be, or not to be--that is the question:",
                "Whether 'tis nobler in the mind to suffer",
                "The slings and arrows of outrageous fortune",
                "Or to take arms against a sea of troubles",
                "And by opposing end them." };
        }

    }
}
