﻿using System;
using System.Collections.Generic;
using System.Xml.Linq;

namespace Programming_CSharp
{
    // 単純な顧客(customer)クラス
    public class Customer
    {
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string EmailAddress { get; set; }
    }

    // メインプログラム
    public class Tester
    {
        static void Main()
        {
            List<Customer> customers = CreateCustomerList();

            var customerXml = new XDocument();
            var rootElem = new XElement("Customers");
            customerXml.Add(rootElem);
            foreach (Customer customer in customers)
            {
                // 顧客オブジェクトを表す新しい要素を作成します。
                var customerElem = new XElement("Customer");

                // FirstNameプロパティを表す要素をCustomer要素に追加します。
                var firstNameElem = new XElement("FirstName",
                    customer.FirstName);
                customerElem.Add(firstNameElem);

                // LastNameプロパティを表す要素をCustomer要素に追加します。
                var lastNameElem = new XElement("LastName",
                    customer.LastName);
                customerElem.Add(lastNameElem);

                // EmailAddressプロパティを表す要素をCustomer要素に追加します。
                var emailAddress = new XElement("EmailAddress",
                    customer.EmailAddress);
                customerElem.Add(emailAddress);

                // 最後にCustomer要素をXML文書に追加します。
                rootElem.Add(customerElem);
            }
            Console.WriteLine(customerXml.ToString());
            Console.Read();
        }

        // サンプルデータから顧客リストを作成します。
        private static List<Customer> CreateCustomerList()
        {
            List<Customer> customers = new List<Customer>
            {
                new Customer { FirstName = "Orlando",
                                LastName = "Gee",
                                EmailAddress = "orlando0@hotmail.com"},
                new Customer { FirstName = "Keith",
                                LastName = "Harris",
                                EmailAddress = "keith0@hotmail.com" },
                new Customer { FirstName = "Donna",
                                LastName = "Carreras",
                                EmailAddress = "donna0@hotmail.com" },
                new Customer { FirstName = "Janet",
                                LastName = "Gates",
                                EmailAddress = "janet1@hotmail.com" },
                new Customer { FirstName = "Lucy",
                                LastName = "Harrington",
                                EmailAddress = "lucy0@hotmail.com" }
            };
            return customers;
        }
    }
}
