﻿using System;
using System.IO;
using System.Xml.Serialization;

namespace Programming_CSharp
{
    // 単純な顧客(customer)クラス
    public class Customer
    {
        [XmlAttribute]
        public string FirstName { get; set; }

        [XmlIgnore]
        public string LastName { get; set; }

        public string EmailAddress { get; set; }

        // オブジェクトのプロパティを文字列として表現できるよう、
        // Object.ToString()をオーバーライドします。
        public override string ToString()
        {
            return string.Format("{0} {1}\nEmail: {2}",
                FirstName, LastName, EmailAddress);
        }
    }

    // メインプログラム
    public class Tester
    {
        static void Main()
        {
            Customer c1 = new Customer
            {
                FirstName = "Orlando",
                LastName = "Gee",
                EmailAddress = "orlando0@hotmail.com"
            };

            //XmlSerializer serializer = new XmlSerializer(c1.GetType());
            XmlSerializer serializer = new XmlSerializer(typeof(Customer));
            StringWriter writer = new StringWriter();

            serializer.Serialize(writer, c1);
            string xml = writer.ToString();
            Console.WriteLine("XMLとしてのCustomer:\n{0}\n", xml);

            Customer c2 = serializer.Deserialize(new StringReader(xml)) as Customer;
            Console.WriteLine("オブジェクトとしてのCustomer:\n{0}", c2.ToString());

            Console.ReadKey();
        }
    }
}