﻿using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Text;

namespace IpAndSockets
{
    class Program
    {
        static void Main(string[] args)
        {
            {
                // 例13-22 ホスト名に対応するIPアドレスを取得する
                IPHostEntry hostDnsEntry = Dns.GetHostEntry("localhost");
                foreach (IPAddress address in hostDnsEntry.AddressList)
                {
                    Console.WriteLine("種類: {0}, アドレス: {1}", address.AddressFamily,
                        address);
                }
            }


            {
                // 例13-24 ソケットを使用して日時サーバーからデータを取得する
                IPHostEntry hostDnsEntry = Dns.GetHostEntry("time-nw.nist.gov");
                IPAddress serverIp = hostDnsEntry.AddressList[0];

                Socket daytimeSocket = new Socket(
                    serverIp.AddressFamily,
                    SocketType.Stream,
                    ProtocolType.Tcp);
                daytimeSocket.Connect(serverIp, 13);
                string data;

                // 例13-23 TCPソケット経由でASCIIデータを受信する
                using (Stream timeServiceStream = new NetworkStream(daytimeSocket, true))
                using (StreamReader timeServiceReader = new StreamReader(timeServiceStream,
                                                                         Encoding.ASCII))
                {
                    data = timeServiceReader.ReadToEnd();
                }

                Console.WriteLine(data);
            }
        }
    }
}
