﻿using System;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace SocketServer
{
    class Program
    {
        static void Main(string[] args)
        {
            // 例13-27 日時サービス用の全コード
            // 例13-25 受信したTCP接続をリッスンする
            using (Socket daytimeListener = new Socket(
                AddressFamily.InterNetworkV6,
                SocketType.Stream,
                ProtocolType.Tcp))
            {
                daytimeListener.SetSocketOption(
                    SocketOptionLevel.IPv6, (SocketOptionName) 27, 0);

                IPEndPoint daytimeEndpoint = new IPEndPoint(IPAddress.IPv6Any, 13);
                daytimeListener.Bind(daytimeEndpoint);
                daytimeListener.Listen(20);

                // 例13-26 受信用接続の許可
                while (true)
                {
                    Socket incomingConnection = daytimeListener.Accept();
                    using (NetworkStream connectionStream =
                                        new NetworkStream(incomingConnection, true))
                    using (StreamWriter writer = new StreamWriter(connectionStream))
                    {
                        writer.WriteLine(DateTime.Now);
                    }
                }
            }
        }
    }
}