﻿using System;
using ChatClient.ChatService;
using System.ServiceModel;

namespace ChatClient
{
    class Program
    {
        static void Main(string[] args)
        {
            ChatCallback callbackObject = new ChatCallback();
            InstanceContext clientContext = new InstanceContext(callbackObject);
            ChatServiceClient chatProxy = new ChatServiceClient(clientContext);

            Console.WriteLine("名前を入力してください:");
            bool ok = false;
            while (!ok)
            {
                string name = Console.ReadLine();
                ok = chatProxy.Connect(name);
                if (!ok)
                {
                    Console.WriteLine("入力された名前は現在使用中です。別の名前を入力してください。");
                }
            }
            while (true)
            {
                Console.WriteLine("ノートを入力します(Enterキーで終了):");
                string note = Console.ReadLine();
                if (string.IsNullOrEmpty(note))
                {
                    break;
                }
                chatProxy.PostNote(note);
            }
            chatProxy.Disconnect();
        }
    }
}
