﻿using System;
using System.IO;
using System.Threading;
using System.Windows;

namespace Affinity
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            // 以降のサンプルコードでログファイルの内容を読み取れるようにあらかじめ準備しておきます。
            using (StreamWriter w = File.AppendText(@"c:\temp\log.txt"))
            {
                w.WriteLine("アプリケーションは{0}に開始されました", DateTime.Now);
            }
        }

        private void runWorkAsyncButton_Click(object sender, RoutedEventArgs e)
        {
            // 例16-7 SynchronizationContext でスレッドアフィニティを処理する
            SynchronizationContext originalContext = SynchronizationContext.Current;

            ThreadPool.QueueUserWorkItem(delegate
            {
                string text = File.ReadAllText(@"c:\temp\log.txt");
                originalContext.Post(delegate
                {
                    myTextBox.Text = text;
                }, null);
            });
        }
    }
}
