﻿using System;
using System.Threading;
using System.Text;

class Program
{
    static void Main(string[] args)
    {
        StringBuilder result = new StringBuilder();

        // StringBuilderをスレッド間で共有しています。良くありません!
        Thread t1 = new Thread(() => Go(result, "One"));
        Thread t2 = new Thread(() => Go(result, "Two"));

        t1.Start();
        t2.Start();

        Go(result, "Main");

        t1.Join();
        t2.Join();

        Console.WriteLine(result);
    }

    static void Go(StringBuilder sb, string name)
    {
        for (int i = 0; i < 100; ++i)
        {
            // すべてのスレッドが同じStringBuilderを使用しています。良くありません!
            sb.AppendFormat("{0}: {1}", name, i);
            sb.AppendLine();
        }
    }
}