﻿using System.Collections.Generic;

namespace MonitorExamples
{
    class MostRecentlyUsed
    {
        private List<string> items = new List<string>();
        private int maxItems;

        public MostRecentlyUsed(int maximumItemCount)
        {
            maxItems = maximumItemCount;
        }

        public void UseItem(string item)
        {
            // 既にitemがリスト内にあり、しかもリストの最初にない場合には
            // このitemを最初に移動するため、既にある場所から削除します。
            int itemIndex = items.IndexOf(item);
            if (itemIndex > 0)
            {
                items.RemoveAt(itemIndex);
            }

            // 既にitemがリストの最初にある場合は、何もする必要がありません。
            if (itemIndex != 0)
            {
                items.Insert(0, item);
                // 指定した最大数以上の要素を保持しないようにします。
                if (items.Count > maxItems)
                {
                    items.RemoveAt(items.Count - 1);
                }
            }
        }

        public IEnumerable<string> GetItems()
        {
            return items.ToArray();
        }
    }
}
