﻿using System.Net;
using System.Threading.Tasks;
using System.Windows;

namespace SchedulerContext
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        // 例16-21 UI スレッド上の継続
        void OnButtonClick(object sender, RoutedEventArgs e)
        {
            TaskScheduler uiScheduler =
                TaskScheduler.FromCurrentSynchronizationContext();
            Task<string>.Factory.StartNew(GetData)
                            .ContinueWith((task) => UpdateUi(task.Result),
                                          uiScheduler);
        }

        string GetData()
        {
            WebClient w = new WebClient();
            return w.DownloadString("http://oreilly.com/");
        }

        void UpdateUi(string info)
        {
            myTextBox.Text = info;
        }
    }
}
