﻿using System.Net;
using System.Threading.Tasks;
using System.Windows;

namespace SchedulerContext
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        void OnButtonClick(object sender, RoutedEventArgs e)
        {
            // 例16-22 APM 実装からのタスクの作成
            TaskScheduler uiScheduler = TaskScheduler.FromCurrentSynchronizationContext();
            Task<IPHostEntry>.Factory.FromAsync(
                                Dns.BeginGetHostEntry, Dns.EndGetHostEntry,
                                "oreilly.com", null)
                .ContinueWith((task) => UpdateUi(task.Result.AddressList[0].ToString()),
                              uiScheduler);
        }

        void UpdateUi(string info)
        {
            myTextBox.Text = info;
        }
    }
}
