﻿using System;
using System.Reflection;

namespace DynamicallyInvokingAMethod
{
    public class Tester
    {
        public static void Main()
        {
            Type theMathType = Type.GetType("System.Math");
            // System.Mathにはパブリックのコンストラクタがないので、
            // 以下のコードは例外が発生します。
            // Object theObj =
            //     Activator.CreateInstance(theMathType);

            // 1つの要素を含む配列
            Type[] paramTypes = new Type[1];
            paramTypes[0] = Type.GetType("System.Double");

            // Cos()のMethodInfoを取得
            MethodInfo CosineInfo =
            theMathType.GetMethod("Cos", paramTypes);

            // 実際の引数を持った配列を作成します
            Object[] parameters = new Object[1];
            parameters[0] = 45 * (Math.PI / 180); // ラジアン表記の45度
            Object returnVal =
                CosineInfo.Invoke(theMathType, parameters);
            Console.WriteLine(
                "コサイン45度は {0}",
                returnVal);
        }
    }
}