﻿using System;

namespace CustomAttributes
{
    // クラスのメンバをターゲットとする属性を作成します
    [AttributeUsage(AttributeTargets.Class |
                    AttributeTargets.Constructor |
                    AttributeTargets.Field |
                    AttributeTargets.Method |
                    AttributeTargets.Property,
    AllowMultiple = true)]
    public class BugFixAttribute : System.Attribute
    {
        // ポジショナル引数用のコンストラクタ
        public BugFixAttribute
        (
            int bugID,
            string programmer,
            string date
        )
        {
            this.BugID = bugID;
            this.Programmer = programmer;
            this.Date = date;
        }

        // アクセサ
        public int BugID { get; private set; }
        public string Date { get; private set; }
        public string Programmer { get; private set; }

        // 名前指定パラメータ用のプロパティ
        public string Comment { get; set; }
    }

    // ********* クラスに属性を指定します ********

    [BugFixAttribute(121, "Jesse Liberty", "01/03/08")]
    [BugFixAttribute(107, "Jesse Liberty", "01/04/08",
                        Comment = "Fixed off by one errors")]
    public class MyMath
    {
        public double DoFunc1(double param1)
        {
            return param1 + DoFunc2(param1);
        }

        public double DoFunc2(double param1)
        {
            return param1 / 3;
        }
    }
    public class Tester
    {
        static void Main(string[] args)
        {
            MyMath mm = new MyMath();
            Console.WriteLine("DoFunc(7)を実行。結果: {0}",
            mm.DoFunc1(7));
        }
    }
}