﻿using System;
using Microsoft.CSharp.RuntimeBinder;

namespace OrdinaryTypes
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                // 例18-11 　簡単なオブジェクトをdynamic から使う
                dynamic a = new MyType { Text = "One", Number = 123 };
                Console.WriteLine(a.Text);
                Console.WriteLine(a.Number);
                Console.WriteLine(a.Problem);
            }
            catch (RuntimeBinderException)
            {
                Console.WriteLine("意図通り例外が発生しました。");
            }

            {
                // 例18-12 dynamic を使ってプロパティを設定しメソッドを呼び出す
                dynamic a = new MyType();
                a.Number = 42;
                a.Text = "Foo";
                Console.WriteLine(a);
                dynamic b = new MyType();
                b.SetBoth("Bar", 99);
                Console.WriteLine(b);

                // 例18-13 + 演算子のオーバーロードを使う
                MyType c = AddAnything(a, b);
                Console.WriteLine(c);
            }
        }

        static dynamic AddAnything(dynamic a, dynamic b)
        {
            dynamic result = a + b;
            Console.WriteLine(result);
            return result;
        }
    }
}
