﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Office.Interop.Word;

namespace OptionalRef
{
    class Program
    {
        static void Main(string[] args)
        {
            Application wordApp = new Application();
            wordApp.ChangeFileOpenDirectory(Environment.CurrentDirectory);

            {
                // 例19-4 参照のある醜いコード
                object fileName = @"WordFile.docx";
                object missing = System.Reflection.Missing.Value;
                object readOnly = true;
                var doc = wordApp.Documents.Open(ref fileName, ref missing, ref readOnly,
                    ref missing, ref missing, ref missing, ref missing, ref missing,
                    ref missing, ref missing, ref missing, ref missing, ref missing,
                    ref missing, ref missing, ref missing);


                ((_Document) doc).Close();
            }

            wordApp.ChangeFileOpenDirectory(Environment.CurrentDirectory);
            {
                object fileName = @"WordFile.docx";
                object missing = System.Reflection.Missing.Value;
                object readOnly = true;

                // 例19-5 ref を省略する
                var doc = wordApp.Documents.Open(fileName, missing, readOnly,
                    missing, missing, missing, missing, missing,
                    missing, missing, missing, missing, missing,
                    missing, missing, missing);


                ((_Document) doc).Close();
            }

            wordApp.ChangeFileOpenDirectory(Environment.CurrentDirectory);
            {
                object fileName = @"WordFile.docx";
                object missing = System.Reflection.Missing.Value;
                object readOnly = true;

                // 例19-6 省略可能な引数
                var doc = wordApp.Documents.Open(FileName: fileName, ReadOnly: readOnly);


                ((_Document) doc).Close();
            }
        }
    }
}
