﻿using System;
using System.IO;
using System.Runtime.InteropServices;

namespace UsingPInvoke
{
    class Tester
    {

        // P/Invokeを使いたいWinAPIメソッドを宣言します
        [DllImport("kernel32.dll", EntryPoint = "MoveFile",
            ExactSpelling = false, CharSet = CharSet.Unicode,
            SetLastError = true)]
        static extern bool MoveFile(
            string sourceFile, string destinationFile);

        public static void Main()
        {
            // インスタンスを作成し、実行します
            Tester t = new Tester();
            string theDirectory = @"c:\test\media";
            DirectoryInfo dir =
                new DirectoryInfo(theDirectory);
            t.ExploreDirectory(dir);
        }

        // ディレクトリ名を設定します
        private void ExploreDirectory(DirectoryInfo dir)
        {

            // サブディレクトリを作成します
            string newDirectory = "newTest";
            DirectoryInfo newSubDir =
                dir.CreateSubdirectory(newDirectory);

            // ディレクトリにあるファイルをすべて取得し、
            // 新しいディレクトリにコピーします。
            FileInfo[] filesInDir = dir.GetFiles();
            foreach (FileInfo file in filesInDir)
            {
                string fullName = newSubDir.FullName +
                "\\" + file.Name;
                file.CopyTo(fullName);
                Console.WriteLine("{0} をnewTestにコピーしました。",
                file.FullName);
            }

            // コピーされたファイルのコレクションを取得します。
            filesInDir = newSubDir.GetFiles();

            // 削除と名前の変更を行います
            int counter = 0;
            foreach (FileInfo file in filesInDir)
            {
                string fullName = file.FullName;

                if (counter++ % 2 == 0)
                {
                    // Win32 APIをP/Invokeします
                    Tester.MoveFile(fullName, fullName + ".bak");
                    Console.WriteLine("{0} を {1}に変更しました。",
                    fullName, file.FullName);
                }
                else
                {
                    file.Delete();
                    Console.WriteLine("{0} を削除しました。",
                    fullName);
                }
            }
            // サブディレクトリを削除します
            newSubDir.Delete(true);
        }
    }
}