﻿using System.Collections.Generic;
using System.Windows.Controls;

namespace AvWorksBrowser
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            CategoryViewModel.GetCategories(delegate(IList<CategoryViewModel> categoryViewModels)
            {
                // 例20-29 リストアイテムの項目を提供する
                categoryList.ItemsSource = categoryViewModels;
            });
        }

        // 例20-30 選択されたカテゴリの製品を読み込む
        private void categoryList_SelectionChanged(object sender,
        SelectionChangedEventArgs e)
        {
            CategoryViewModel currentCategory =
            categoryList.SelectedItem as CategoryViewModel;
            if (currentCategory == null)
            {
                productList.ItemsSource = null;
            }
            else
            {
                productList.ItemsSource = currentCategory.Products;
            }
        }
    }
}
